#include "w32dlfcn.h"
#include <stdio.h>

#define LIB1	"lib1.so"
#define LIB2	"lib2.so"
#define LIB3	"lib3.so"

typedef void (*pvfv)(void);

int main()
{
  void *l1, *l2, *l3;
  pvfv f1, f2, f3;

  if (!(l1= dlopen(LIB1, RTLD_LOCAL)))	printf("main: "LIB1": %s\n", dlerror());
  if (!(l2= dlopen(LIB2, RTLD_GLOBAL)))	printf("main: "LIB2": %s\n", dlerror());
  if (!(l3= dlopen(LIB3, RTLD_GLOBAL)))	printf("main: "LIB3": %s\n", dlerror());

  if (!(f1= dlsym(l1, "function1")))	printf("main: l1 function1: %s\n", dlerror());
  if (!(f2= dlsym(l2, "function2")))	printf("main: l2 function2: %s\n", dlerror());
  if (!(f3= dlsym(l3, "function3")))	printf("main: l3 function3: %s\n", dlerror());

  printf("main: lib1 %p %p\n", l1, f1);
  printf("main: lib2 %p %p\n", l2, f2);

  if (f1) f1();
  if (f2) f2();

  dlclose(l2);
  if (f1) f1();
  dlclose(l1);

  return 0;
}
